package org.jboss.security.auth.spi;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.security.AccessController;
import java.security.PrivilegedActionException;
import java.security.PrivilegedExceptionAction;
import javax.management.MBeanServer;
import javax.management.MBeanServerInvocationHandler;
import javax.management.ObjectName;
import org.jboss.mx.util.MBeanServerLocator;
import org.jboss.security.plugins.JaasSecurityDomainMBean;

class DecodeAction implements PrivilegedExceptionAction {
  String password;
  
  ObjectName serviceName;
  
  DecodeAction(String password, ObjectName serviceName) {
    this.password = password;
    this.serviceName = serviceName;
  }
  
  public Object run() throws Exception {
    MBeanServer server = MBeanServerLocator.locateJBoss();
    JaasSecurityDomainMBean securityDomain = MBeanServerInvocationHandler.<JaasSecurityDomainMBean>newProxyInstance(server, this.serviceName, JaasSecurityDomainMBean.class, false);
    byte[] secret = securityDomain.decode64(this.password);
    String secretPassword = new String(secret, "UTF-8");
    return secretPassword.toCharArray();
  }
  
  static char[] decode(String password, ObjectName serviceName) throws Exception {
    org.jboss.security.auth.spi.DecodeAction action = new org.jboss.security.auth.spi.DecodeAction(password, serviceName);
    try {
      char[] decode = AccessController.<char[]>doPrivileged(action);
      return decode;
    } catch (PrivilegedActionException e) {
      throw e.getException();
    } 
  }
}
